﻿
var feed;
window.onload = function() {
	feed = new Feed (skeletonConfig['feedURL'], skeletonConfig['feedTitle'], skeletonConfig['feedDescr']);
	window['controller'] = new Controller();
	feed.setUpdateInterval(15);
	feed.setDataHandler( parsers[ skeletonConfig['feedVersion'] ] );
	feed.addItemListener( onNewItemsHandler );
	feed.setMaxItems(skeletonConfig['maxItems']);
	feed.forceUpdate();
	
	document.title = skeletonConfig['feedTitle'];
	document.getElementById('widgetTitle').firstChild.nodeValue = skeletonConfig['feedTitle'];
	
    /* Advanced - tooltip */
    var unreadItems = document.getElementById('unread');
	unreadItems.addTooltip(unreadItems.title, 10, 10, 6, 0, false, true);
	/* End advanced */
  
  var disanim = document.getElementById('disanim');
  if (widget.preferenceForKey('animationOn') == 'false') {
    disanim.checked = 'true'; // yes, it's checked="checked", but this is easier :-)
  }
  switchAnim();
	
	var baseHref = document.createElement('base');
	baseHref.href = skeletonConfig['feedURL'];
	document.getElementsByTagName('head')[0].appendChild(baseHref);
	
	/* Advanced - lastupdate */
	setInterval( updateAges, 1000 * 60 );
	/* End advanced */
	
	window.resizeTo(400,250);
}

function onNewItemsHandler(noChange, err) {
	/* Advanced - lastupdate */
    updateStatus(err);
    /* End advanced */
	
	var container = document.getElementById('itemList');
	var list = feed.getItemList();

   	/* Advanced - modified for lastupdate */
	if (err) {
        if (container.firstChild) {
    		return;
    	}

		var li = document.createElement('li');
		li.appendChild( document.createTextNode( '(Unable to display feed)' ) );
		container.insertBefore( li, container.firstChild );
		li.id = 'noContent';
		return;
	}
   	/* End advanced */

	if (list.length == 0) {
		container.innerHTML = '';
		var li = document.createElement('li');
		li.appendChild( document.createTextNode( '(No feed items found)' ) );
		container.appendChild(li);
		li.id = 'noContent';
		return;
	}
	
	// Unchanged feed, leave it alone
    if (noChange) return;
		
	// Display feed items
	container.innerHTML = '';
	var pointer = null, li = null, content = null;
	
	for (var i = 0; pointer = list[i]; i++) {
		li = document.createElement('li');
		li.className = pointer.read ? 'read' : '';
		li.guid = pointer.getGUID();
		container.appendChild( li );
		
		var tit = pointer.getTitle() || '(No title)';
		if ( typeof tit == 'string' ) tit = document.createTextNode( tit );
		var h2 = document.createElement('h2');
		h2.className = 'postTitle';
		h2.appendChild( tit );
		li.appendChild( h2 );
		
		var content = document.createElement('div');
		var h3 = document.createElement('h3');
		h3.className = 'dateTime';
		/* Advanced - lastupdate */
		var pub = pointer.getDate();
		h3.appendChild( document.createTextNode( pub ? pub.toAge() : '(No date)' ) );
		h3.timestamp = pub ? pub.getTime() : 0;
		/* End advanced */
        content.appendChild( h3 );
		li.appendChild( content );
		li.expander = content;
		
		var desc = pointer.getDesc() || document.createTextNode( '(No text)' );
		if ( typeof desc == 'string' ) desc = document.createTextNode( desc );
		content.appendChild( desc );
		
		var link, href = pointer.getLink();
		if ( href ) {
			link = document.createElement('a');
			link.href = href;
			link.appendChild( document.createTextNode( 'Go to entry' ) );
		} else {
			link = document.createTextNode( '(No link)' );
		}
		link.className = 'morelink';
		content.appendChild(link);
		
	}

    updateUnread();	

	/* Advanced - fancy unread */
	if (feed.getUnreadCount() > 0) {
		document.getElementById('unread').style.visibility = 'visible';
		var animation = document.getElementById('unread').createAnimation();
		animation.style.opacity = 0;
		animation.speed = 5;
		animation.accelerationProfile = animation.constant;
		animation.addAnimation('opacity', animation.style.opacity, '1').run();
	}
	/* End advanced */
}
	
function Controller() {
	function clickHandler(event) {
		var el = event.target;
		event.stopPropagation();
		
		while (el) {
			switch (el.nodeName.toLowerCase()) {
				case 'h2' :
					if (el.className == 'postTitle') {
						clickOnTitleHandler(el.parentNode);
						return;
					}
					break;
				case 'a' :
					// Happens automatically
					//widget.openURL(el.getAttribute('href'));
					return;
				case 'ul' :
					if (el.id == 'itemList') {
						return;
					}
					break;
				default :
					break;
			}
			el = el.parentNode;
		}
	}
	
	function clickOnTitleHandler(ele) {
		var adiv = ele.expander;
		var anim = adiv.aniobj;

		if (! anim) {
			anim = adiv.aniobj = adiv.createAnimation();
			anim.adiff = Math.min( 250, adiv.scrollHeight );
			anim.bdiff = 0;
			anim.speed = 20;
			anim.accelerationProfile = Animation.prototype.decelerate;
			anim.style.height = '0px';
			anim.onfinish = function() {
				adiv.style.overflow = '';
				if ( ! ele.hasClass('active') ) {
					window.resizeBy( 0, - Math.max( 0, anim.adiff - anim.bdiff ) );
					anim.bdiff = 0;
				}
			}
			anim.onstart = function() {
				adiv.style.overflow = 'hidden';
				if ( ele.hasClass('active') ) {
					window.resizeBy( 0, Math.max( 0, anim.adiff - anim.bdiff ) );
					anim.bdiff = 0;
				}
			}
		}
		
		if ( ele.hasClass('active') ) {
			ele.dropClass('active');
			anim.addAnimation('height', anim.style.height, '0px').run();
		} else {
			var all = ele.parentNode.getElementsByTagName('li');
			var pointer;
			
			for (var i = 0; pointer = all[i]; i++) {
				if ( pointer.hasClass('active') ) {
					pointer.dropClass('active');
					var bnim = pointer.expander.aniobj;
					bnim.bdiff = anim.adiff;
					anim.bdiff = bnim.adiff;
					bnim.addAnimation('height', bnim.style.height, '0px').run();
					break;
				}
			}

			/* Advanced - fancy unread */
			if (feed.getUnreadCount() == 1 && !ele.hasClass('read')) {
				var urani = document.getElementById('unread').createAnimation();
				urani.style.opacity = 1;
				urani.speed = 5;
				urani.accelerationProfile = urani.constant;
				urani.addAnimation('opacity', urani.style.opacity, '0').run();
				urani.onfinish = function() {
					document.getElementById('unread').style.visibility = 'hidden';
				}
			}
			/* End advanced */

			feed.setItemRead(ele.guid);
			ele.addClass('active');
			ele.addClass('read');
			updateUnread();
			
			anim.addAnimation('height', '0px', anim.adiff + 'px').run();
		}
	}
	
	/* Entire function changed in advanced */
	var minimized = false;
	this.expandMinimize = function() {

		var ele			= document.getElementById('content'),
		animation		= ele.animation,
		ele2				= document.getElementById('wrapper'),
		animation2	= ele2.animation,
		expMin			= document.getElementById('expandMinimize');
		
		if (! animation) {
			var sp = 15;
			
			animation = ele.animation = ele.createAnimation();
			animation.accelerationProfile = Animation.prototype.decelerate;
			animation.speed = sp;
			
			animation2 = ele2.animation = ele2.createAnimation();
			animation2.accelerationProfile = Animation.prototype.decelerate;
			animation2.speed = sp;
			
			animation.onfinish = function() {
				if ( minimized ) {
					document.getElementById('lastUpdate').style.visibility = 'hidden';
					document.getElementById('reload').style.visibility = 'hidden';
                    window.resizeBy( -150, -ele.scrollHeight );
					expMin.className = 'expand';
				} else {
					expMin.className = 'minimize';
					ele.style.height = 'auto';
				}
			}
			animation.onstart = function() {
				if (! minimized) {
					document.getElementById('lastUpdate').style.visibility = '';
					document.getElementById('reload').style.visibility = '';
                    window.resizeBy( 150, ele.scrollHeight );
                }
			}
		}
		
		if (minimized) {
			minimized = false;
			animation.addAnimation('height', '0px', ele.scrollHeight + 'px').run();
			animation2.addAnimation('width', '200px', '350px').run();
		} else {
			minimized = true;
			animation.addAnimation('height', ele.scrollHeight + 'px', '0px').run();
			animation2.addAnimation('width', '350px', '200px').run();
		}
	}
	/* End changed */

	document.getElementById('itemList').addEventListener('click', clickHandler, true);
	document.getElementById('expandMinimize').addEventListener( 'click', this.expandMinimize, false );
	document.getElementById('flip').addEventListener( 'click', flipSide, false );
	document.getElementById('disanim').addEventListener( 'click', switchAnim, false );

    /* Advanced - lastupdate */
	document.getElementById('reload').addEventListener( 'click', feed.forceUpdate, false );
	document.getElementById('reload').addEventListener( 'click', updateStatus, false );
	/* End Advanced */
}

/* Advanced - modified */
function updateUnread() { 
	document.getElementById('unread').firstChild.nodeValue = feed.getUnreadCount();
}
/* End advanced */

/* Advanced - modified for lastupdate */
var flipped = false;
function flipSide() {
    
    var header = document.getElementById('widgetTitle');
    var itemList = document.getElementById('itemList');
    var back  = document.getElementById('back');
    var lastUpdate = document.getElementById('lastUpdate');
    var reload = document.getElementById('reload');
    
    var con = document.getElementById('content');
    var before = con.offsetHeight;
    
    if (flipped) {
        itemList.style.display = '';
        back.style.display = '';
        reload.style.display = '';
        lastUpdate.style.display = '';
        header.firstChild.nodeValue = skeletonConfig['feedTitle'];
        flipped = false;
    } else {
        itemList.style.display = 'none';
        back.style.display = 'block';
        reload.style.display = 'none';
        lastUpdate.style.display = 'none';
        header.firstChild.nodeValue = 'About Widgetize!';
        flipped = true;
    }
    
    var after = con.offsetHeight;
    window.resizeBy( 0, after - before );

}
/* End advanced */

function switchAnim() {
  var disanim = document.getElementById('disanim');
  Animation.on = !disanim.checked;
  widget.setPreferenceForKey(!disanim.checked, 'animationOn')
}

/* Advanced - lastupdate */
function updateStatus(err) {
	var lastUpdate = document.getElementById('lastUpdate');
	
	lastUpdate.timestamp = new Date();
	
	lastUpdate.firstChild.nodeValue = 'Updating feed...';
	
	setTimeout( function() {
		lastUpdate.firstChild.nodeValue = err && typeof err == 'string' ? (
			'[' + padZero(lastUpdate.timestamp.getHours()) + ':' +
			padZero(lastUpdate.timestamp.getMinutes()) + '] ' +
			err
		) : (
			'Last updated ' +
			padZero(lastUpdate.timestamp.getHours()) + ':' +
			padZero(lastUpdate.timestamp.getMinutes())
		);
	}, 1000 );
}

function updateAges() {
	var ages = document.getElementsByTagName('h3'), age;
	for (var i = 0; age = ages[i]; i++) {
		if (age.timestamp) age.firstChild.nodeValue = new Date(age.timestamp).toAge();
	}
}
