﻿
var months = [
	'January',
	'February',
	'March',
	'April',
	'May',
	'June',
	'July',
	'August',
	'September',
	'October',
	'November',
	'December'
];
var tw = {
	second : 'second',
	seconds : 'seconds',
	minute : 'minute',
	minutes : 'minutes',
	hour : 'hour',
	hours : 'hours',
	yesterday : 'Yesterday',
	and : 'and',
	ago : 'ago',
	today : 'Today',
	at : ', ',
	future : 'in the future',
	date : '%MONTH% %DATE%',
	longdate : '%MONTH% %DATE%, %YEAR%'
}

Date.prototype.toAge = function() {

	var now = new Date();
	var yesterday = new Date( now.getFullYear(), now.getMonth(), now.getDate() );

	var delta = yesterday.getTime() - this.getTime();
	var ticks = now.getTime() - this.getTime();

	if ( delta > 0 || ticks < 0 ) {
		// Yesterday or before
		if ( delta < 1000 * 60 * 60 * 24 && ticks > 0 ) {
			// Yesterday
			return tw.yesterday;
		} else {
			// Long ago
			var d = (now.getFullYear() != this.getFullYear()) ? tw.longdate.replace( '%YEAR%', this.getFullYear() ) : tw.date;
			d = d.replace( '%MONTH%', months[this.getMonth()] ).replace( '%DATE%', this.getDate() );
			if (ticks < 0) d += ' (' + tw.future + ')';
			return d;
		}
	} else {
		// Today
		
		if (ticks < 0) {
			return tw.future;
		}
		// Seconds
		ticks = Math.floor( ticks / 1000 );
		if (ticks < 60) {
			return ticks + ' ' + (ticks == 1 ? tw.second : tw.seconds) + ' ' + tw.ago;
		}
		// Less than, or an hour ago
		ticks = Math.floor( ticks / 60 );
		if (ticks <= 60) {
			if (ticks < 60) {
				return ticks % 60 + ' ' + (ticks == 1 ? tw.minute : tw.minutes) + ' ' + tw.ago;
			} else {
				return '1 ' + tw.hour + ' ' + tw.ago;
			}
		}
		// Less than, or two hours ago
		if (ticks <= 120) {
			if (ticks < 120) {
				return '1 ' + tw.hours + ' ' + tw.and + ' ' + ticks % 60 + ' ' +
					(ticks == 1 ? tw.minute : tw.minutes) + ' ' + tw.ago;
			} else {
				return '2 ' + tw.hours + ' ' + tw.ago;
			}
		}
		// Otherwise, write out the time
		else {
			return tw.today + tw.at + ' ' + padZero(this.getHours()) + ':' + padZero(this.getMinutes());
		}
	}	
};

var padZero = function(n) {
	return (n < 10) ? '0' + n : '' + n;
};