﻿
HTMLElement.prototype.hasClass = function(c) {
	return (" " + this.className + " ").indexOf(" " + c + " ") != -1;
}
/**
 * Adds a CSS class to the element
 * @param {String} c Class to add
 * @return True if the class was added, false if element already had the class
 * @type Boolean
 */
HTMLElement.prototype.addClass = function(c) {
	if (!this.hasClass(c)) {
		this.className = this.className + " " + c;
		return true;
	}
	return false;
}
/**
 * Removes a CSS class from the element
 * @param {String} c Class to remove
 * @return True if the class was removed, flase if element didn't have the class
 * @type Boolean
 */
HTMLElement.prototype.dropClass = function(c) {
	if (this.hasClass(c)) {
		this.className = (" " + this.className + " ").replace(" " + c + " ", " ");
		return true;
	}
	return false;
}
